/**
 * 2007-2020 PrestaShop
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to http://www.prestashop.com for more information.
 *
 * @author    PrestaShop SA <contact@prestashop.com>
 * @copyright 2007-2020 PrestaShop SA
 * @license   http://opensource.org/licenses/afl-3.0.php  Academic Free License (AFL 3.0)
 *  International Registered Trademark & Property of PrestaShop SA
 */
 (function($) {
    var baseUrl = 'https://app.revechat.com/';
    window.ExistingAccoutVerify = function (response) {
       console.log(`response`,response);

       if (response.error)
       {
           $('.ajax_message').removeClass('wait').addClass('message alert').html('Incorrect REVE Chat login.');
           return false;
       }
       else
       {
           if( response.data.account_id ) {
               
               $('input[name=REVECHAT_AID]').val(response.data.account_id);
               $('#configuration_form.revechat').submit();

           } else {
               console.log(`Response Error: `,response);
           }
       }
    }
    var ReveChat =
    {
        init: function () {
            this.toggleForms();
            this.bindFormSubmit();
        },
        toggleForms: function ()
        {
            var toggleForms = function ()
            {
                if ($('#new_revechat_account').is(':checked'))
                {
                    $('#fieldset_revechat_already_have_1').hide();
                    $('#fieldset_revechat_new_account_2').show();
                }
                else if ($('#has_revechat_account').is(':checked'))
                {
                    $('#fieldset_revechat_new_account_2').hide();
                    $('#fieldset_revechat_already_have_1').show();
                }
            };
            toggleForms();
            $('#configuration_form.revechat input').click(toggleForms);
        },
        bindFormSubmit: function () {
            $('#revechat_remove').on('click',function(){
                $('#configuration_form.revechat').submit();

            });
            $('button[name=submit-revechat]').on('click',function(e)
            {
                //e.preventDefault();
                if ((
                    (parseInt($('input[name=REVECHAT_AID]').val()) > 0 )) || $('#has_revechat_account').is(':checked'))
                {

                    return ReveChat.alreadyHaveAccountForm();
                }
                else
                {
                    return ReveChat.newLicenseForm();
                }

            });
        },
        alreadyHaveAccountForm: function()
        {
            if(this.validEmail())
            {
                if(
                    (parseInt($('input[name=REVECHAT_AID]').val()) == 0)||
                    $('input[name=REVECHAT_AID]').val() == ''
                )
                {
                    var login = $.trim($('#edit-revechat-account-email').val());
                    if(!login.length)
                    {
                        $('#edit-revechat-account-email').focus();
                        return false;
                    }

                    $('.ajax_message').removeClass('message').addClass('wait').html('Please wait&hellip;');
                    var signInUrl = baseUrl +'license/adminId/'+$('#edit-revechat-account-email').val()+'/?callback=window.ExistingAccoutVerify';

                    $.ajax({
                        type: 'GET',
                        dataType: "text",
                        // dataType: "jsonp",
                        url: signInUrl, 
                        // jsonpCallback: "window.ExistingAccoutVerify",
                        beforeSend: function() {
                        },
                        success: function(response) {
                            eval(response);
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            console.log("Error:1656");
                        }

                    }); // end of ajax saving.
                }
            }
            else
            {
                $('.ajax_message').removeClass('wait').addClass('message alert').html('Invalid Email.');
                $('#edit-revechat-account-email').focus();
                return false;
            }
            return true;
        },
        newLicenseForm: function()
        {
            if (parseInt(($('input[name=REVECHAT_AID]').val()) > 0))
            {
                return true;
            }

            if(this.validateNewLicenseForm())
            {
                $('.ajax_message').removeClass('message').addClass('wait').html('Please wait...');
                ReveChat.createLicense();
            }
            return false;
        },
        createLicense: function()
        {
            var signUpUrl = baseUrl + 'revechat/cms/api/signup.do';

            $.ajax({
                data: { 
                    'firstname':$('#revechat_name').val(),
                    'lastname':' ',
                    'mailAddr':$('#revechat_email').val(),
                    'password':$('#revechat_password').val(),
                    'phoneNo':$('#revechat_phone').val(),
                    'companyWebsite':$('#revechat_website').val()
                },
                type:'POST',
                url:signUpUrl,
                dataType: 'json',
                cache:false,
                success: function(response) {

                    if(void 0 != response.accountId) {
                        $('input[name=REVECHAT_AID]').val(response.accountId);
                        $('#configuration_form.revechat').submit();
                    } else {

                        $('.ajax_message').html(response.message).addClass('message alert').removeClass('wait');
                        return false;
                    }

                }
            });
        },
        validEmail: function()
        {

            if($('#edit-submit').val() != 'Remove')
            {
                if (/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,6}$/i.test($('#edit-revechat-account-email').val()) == false)
                {
                    //alert ('Please enter a valid email address.');
                    $('#edit-email').focus();
                    return false;
                }
            }
            return true;
        },
        validateNewLicenseForm: function()
        {
            if ($('#revechat_name').val().length < 1)
            {
                alert ('Please enter your full name.');
                return false;
            }

            if (/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,6}$/i.test($('#revechat_email').val()) == false)
            {
                alert ('Please enter a valid email address.');
                return false;
            }

            if ($('#revechat_phone').val().length < 1)
            {
                alert ('Please enter your phone number.');
                return false;
            }

            return true;
        },
        getWebsite: function()
        {
            return location.href.replace(/admin\/config\/.*/, '');
        },

        calculateGMT: function()
        {
            var date, dateGMTString, date2, gmt;

            date = new Date((new Date()).getFullYear(), 0, 1, 0, 0, 0, 0);
            dateGMTString = date.toGMTString();
            date2 = new Date(dateGMTString.substring(0, dateGMTString.lastIndexOf(" ")-1));
            gmt = ((date - date2) / (1000 * 60 * 60)).toString();

            return gmt;
        }
    }

    $(document).ready(function()
    {
        ReveChat.init();
    });
})(jQuery);